unit snkStr;
{
SNK String Library, Version 2.2.1 (Jun. 14, 2006; function names checked)
Copyright (c) 1998-2002 Serge Korzhinski (serg@snkey.net; www.snkey.net)
Prev. releases:
Version 2.2 (Jun. 26, 2002; date/time conversions)
Version 2.1.4 (Apr. 13, 2002; ModColor, ExtractFileExtNP)
Version 2.1.3 (Nov. 13, 2001; Few fixes & improvements)
Version 2.1.2 (Jul. 10, 2001; Added WrapLine(); ChangeCase();)
Version 2.1.1 (Jan. 28, 2001; RStrLib 1.4 compatible)
Version 2.1 (Dec. 15, 2000)
Version 2.0 (Mar. 13, 2000)
...
Version 1.0 (as SStrLib, early in 1998)
}
interface

uses sysutils, classes, windows;

function AddSlash(values:string):string;
{ensures that value has '\' as last character (for directory strings)}

function UnSlash(value:string):string;
{remove that value has '\' as last character (for directory strings)}

function UnSlashW(value:string):string;

function AddSlashW(value:string):string;
{add/remove '/'}

function StripTags(value:string):string;
{strip HTML tags from value}
{example: striptags('<TR><TD Align="center">Hello</TD>') = 'Hello'}

function UpcaseTags(s:string):string;
function LocaseTags(s:string):string;
{uppercase/lowercase tags and attributes, but not attr's values!}

function Capitalize(s:string; strong:boolean):string;
{make first letter of each word in string Capital; if strong=true, over letters convert to lowercase}

function Replace(str,s1,s2:string;casesensitive:boolean):string;
{replace all incidences of s1 in str with s2}
{example: replace('We know what we want','we','I',false) = 'I Know what I want'}

function StripSpases(value:string):string; //now simular to stripspaseq

function stripspaseq(value:string):string; //fast

function StripLines(lst:TStrings):string;

function StripAllSpases(value:string):string;
//remove ALL #0..#20

function GetProtocolName(s:string):string;
{http://www.snkey.net -> http://}

function RemoveProtocolName(s:string):string;
{http://www.snkey.net -> www.snkey.net}

{Ver. 2.0 NEW}

function RGBtoWebColor(i: integer):string;
//Convert form system RGB to HTML string

function WebColortoRGB(s: string):integer;
//Convert from HTML string to system RGB

function ModColor(i: integer; scale: double):integer;
//made color lighter or darker

function SplitString(const s: string; const Token: string): TStringList;
//Split string to groups of chars, separated by Token

function ListToString(const lst: TStringList; const Token: string): string;
//Concat a string from List

function BoolToInt(value: boolean):integer;
//return 1 if true, 0 if false

procedure FindXYPosByLen(sl: TStringList; Index: integer; var X,Y: integer);
//Return symbol position in line (X) & number of line (Y)

function RemoveFileExt(fn: string):string;
//Return fn minus .ext

function GetFileExtNP(fn: string):string;
function ExtractFileExtNP(fn: string):string;
//eq ExtractFileExt, but no period

function GetFileDate(filename:string):Tdatetime;
//get system file datetime

function AmpToSymbols(s: string; const convex: boolean = true):string;
// &quot -> "

function SymbolsToAmp(s: string; const convex: boolean = true):string;
// " -> &quot

function UnBrake(s: string):string;
// "string" -> string

function UnGarbage(s: string):string;
// ( string) -> string

function GetCpNumber(s: string):integer;
//for use with RStrLib: get 'DOS', return '866';

function WrapLine(s: string; cpl: integer; const firstpos: integer=0):string;
//word wrap
function UnWrapLine(s: string):string;

function ChangeCase(s: string):string;
// AbC -> aBc

function StrToHex(str: string):string;
// 'j1' -> '6A31'

function HexToStr(hex: string):string;
// '6A31' -> 'j1'

function DateToInStr(date: TDateTime):string;
// TDateTime > '20020131' (Y,M,D)

function InStrToDate(str: string):TDateTime;
// '20020131' > TDateTime

function TimeToInStr(date: TDateTime):string;
// TDateTime > '113001' (H,M,S)

function InStrToTime(str: string):TDateTime;
// '113001' > TDateTime

function DateTimeToInStr(date: TDateTime):string;

function InStrToDateTime(str: string):TDateTime;

function DateTimeToWeb(date: TDateTime):string;
// TDateTime > 'Mon, 01 Jan 2000 00:00:01 GMT'

implementation

function UnWrapLine(s: string):string;
var
 rs: string;
begin
 s:=Replace(s,#32+#172,#172,false);
 if Pos(#13+#10,s)>0 then rs:=#172+#13+#10 else rs:=#172+#10;
 Result:=Replace(s,rs,#32,false);
end;

function WrapLine(s: string; cpl: integer; const firstpos: integer=0):string;
var
 i,x,lnpos: integer;
begin
 if cpl>1 then begin
   lnpos:=firstpos;
   i:=0;
   UnWrapLine(s);
   for x:=1 to length(s) do begin
     inc(lnpos);
     inc(i);
     if (s[i] in [#10,#13]) then begin
       lnpos:=0;
       continue;
     end;
     if lnpos<cpl then continue;
     if (s[i] in [' ',#9,';','>',',']) then begin
       if (not (s[i+1] in [#10,#13])) and (not (s[i-1] in [#10,#13])) then begin
         insert(#172+#10,s,i+1);  //4.0
         inc(i);
         lnpos:=0;
       end;
     end;
   end;
 end;
 Result:=s;
end;

procedure FindXYPosByLen(sl: TStringList; Index: integer; var X,Y: integer);
var
 i,k: integer;
 s: string;
begin
 k:=0;
 X:=1;
 Y:=1;
 for i:=0 to sl.Count-1 do begin
   s:=sl.Strings[i];
   k:=k+length(s)+2;
   if k<Index then continue;
   Y:=i+1;
   X:=Index-k+length(s);
   if (X>1) or (X<1) then X:=X+2;
   exit;
 end;
end;

function AddSlash(values:string):string;
begin
 Result:=values;
 if (length(values)>0) then if (values[length(values)]<>'\') then
   Result:=values+'\'
end;

function UnSlash(value:string):string;
begin
 if (length(value)>0) then if (value[length(value)]='\') then
   delete(value,length(value),1);
 Result:=value;
end;

function AddSlashW(value:string):string;
begin
 Result:=value;
 if (length(value)>0) then if (value[length(value)]<>'/') then
   Result:=value+'/'
end;

function UnSlashW(value:string):string;
begin
 if (length(value)>0) then if (value[length(value)]='/') then
   delete(value,length(value),1);
 Result:=value;
end;

function GetProtocolName(s:string):string;
var
 x:integer;
begin
 x:=pos('//',s);
 if x<=0 then exit;
 s:=copy(s,1,x+3);
 while (length(s)>0) and (s[length(s)]<>'/') do delete(s,length(s),1);
 Result:=s;
end;

function RemoveProtocolName(s:string):string;
var
 x:integer;
begin
 x:=pos('//',s);
 if x>0 then delete(s,1,x+1);
 while (length(s)>0) and (s[1]='/') do delete(s,1,1);
 Result:=s;
end;

function StripTags(value:string):string;
var
 i:integer;
 s:string;
begin
 i:=1;
 s:='';
 while i<=length(value) do begin
   if value[i]='<' then repeat inc(i) until (value[i]='>') else s:=s+value[i];
   inc(i);
 end;
 result:=s;
end;

function UpcaseTags(s:string):string;
var
 j,i:integer;
 c,xc,cc:boolean;
 s1,s2:string;
begin
 j:=1;
 s1:='';
 while j<=length(s) do begin
   if s[j]='<' then begin
     if ((s[j+1])='!') then
      if ((s[j+2])='-') then
       if ((s[j+3])='-') then begin
         s2:=copy(s,j,length(s));
         i:=3+pos('-->',s2);
         j:=j+i;
         delete(s2,i+1,length(s2));
         s1:=s1+s2;
       end;
     xc:=false;
     c:=true;
     cc:=false;
     repeat
       if j>1 then if (s[j]='!') and (s[j-1]='<') then cc:=true;
       if s[j]='"' then xc:=not xc;
       if s[j]='=' then c:=false;
       if (s[j]=' ') then c:=true;
       if j>1 then if (s[j]=' ') and (s[j-1]='=') then c:=false;
       if c and (not xc) and (not cc) then s1:=s1+uppercase(s[j]) else s1:=s1+s[j];
       inc(j);
     until ((s[j]='>') or (j>=length(s)));
     if j<=length(s) then s1:=s1+s[j];
   end else s1:=s1+s[j];
   inc(j);
 end;
 result:=s1;
end;

function Capitalize(s:string; strong:boolean):string;
var
 i,x:integer;
begin
 x:=length(s);
 i:=0;
 if strong then s:=AnsiLowerCase(s);
 while i<x do begin
   if (s[i] in [' ','>','<',#9,#13]) or (i=0) then begin
//   if (s[i]=' ') or (s[i]='>') or (s[i]=#9) or (s[i]=#13) or (i=0) then begin
     while (i<x) and ((ord(s[i])<48) or (s[i]='>') or (s[i]='<')) do inc(i);
     s[i]:=AnsiUpperCase(s[i])[1];
   end;
   inc(i);
 end;
 Result:=s;
end;

function LocaseTags(s:string):string;
var
 j,i:integer;
 c,xc,cc:boolean;
 s1,s2:string;
begin
 j:=1;
 s1:='';
 while j<=length(s) do begin
   if s[j]='<' then begin
     if ((s[j+1])='!') then
      if ((s[j+2])='-') then
       if ((s[j+3])='-') then begin
         s2:=copy(s,j,length(s));
         i:=3+pos('-->',s2);
         j:=j+i;
         delete(s2,i+1,length(s2));
         s1:=s1+s2;
       end;
     xc:=false;
     c:=true;
     cc:=false; //Comment?
     repeat
       if j>1 then if (s[j]='!') and (s[j-1]='<') then cc:=true;
       if s[j]='"' then xc:=not xc;
       if s[j]='=' then c:=false;
       if (s[j]=' ') then c:=true;
       if j>1 then if (s[j]=' ') and (s[j-1]='=') then c:=false;
       if c and (not xc) and (not cc) then s1:=s1+lowercase(s[j]) else s1:=s1+s[j];
       inc(j);
     until ((s[j]='>') or (j>=length(s)));
     if j<=length(s) then s1:=s1+s[j];
   end else s1:=s1+s[j];
   inc(j);
 end;
 result:=s1;
end;

function StripSpases(value:string):string;
//var s1:string;
begin
{ while (pos('  ',value)>0) do begin
   s1:=copy(value,1,pos('  ',value)-1);
   s1:=s1+copy(value,pos('  ',value)+1,length(value));
   value:=s1;
 end;}
 Result:=stripspaseq(value);
end;

function stripspaseq(value:string):string;
var
 s1: string;
 i,max: integer;
begin
 max:=length(value);
 s1:='';
 for i:=1 to max do begin
   if (value[i]<>' ') or (value[i+1]<>' ') then begin
     s1:=s1+value[i];
   end;
 end;
 Result:=s1;
end;

function StripLines(lst: TStrings):string;
var
 i: integer;
begin
 i:=0;
 while i<lst.Count do begin
   if lst[i]='' then begin
     lst.Delete(i);
   end else inc(i);
 end;
 Result:=lst.Text;
end;

function StripAllSpases(value:string):string;
var
 s1: string;
 i,max: integer;
begin
 max:=length(value);
 s1:='';
 for i:=1 to max do begin
   if not (value[i] in [#1..#20]) then begin
     s1:=s1+value[i];
   end;
 end;
 Result:=s1;
end;

function ChangeCase(s: string):string;
var
 i,max: integer;
 c: Char;
begin
 max:=length(s);
 for i:=1 to max do begin
   c:=s[i];
   if c in ['a'..'z'] then c:=UpperCase(c)[1] else
     if c in ['A'..'Z'] then c:=LowerCase(c)[1] else
      if c in [''..''] then c:=AnsiUpperCase(c)[1] else
        if c in [''..''] then c:=AnsiLowerCase(c)[1];
   Result:=Result+c;
 end;
end;

function replace(str,s1,s2:string;casesensitive:boolean):string;
var
 i:integer;
 s,t:string;
begin
 s:='';
 t:=str;
 repeat
   if casesensitive then i:=pos(s1,t) else i:=pos(ansilowercase(s1),ansilowercase(t));
   if i>0 then begin
     s:=s+Copy(t,1,i-1)+s2;
     t:=Copy(t,i+Length(s1),MaxInt);  
   end else s:=s+t;
 until i<=0;
 result:=s;
end;

function RGBtoWebColor(i: integer):string;
var
 s,s1,s2,s3:string;
begin
 s:=inttohex(i,6);
 s1:=copy(s,1,2);
 s2:=copy(s,3,2);
 s3:=copy(s,5,2);
 Result:='#'+s3+s2+s1;
end;

function WebColortoRGB(s: string):integer;
var
 s1,s2,s3:string;
begin
 Result:=0;
 if length(s)=0 then exit;
 if s[1]='#' then delete(s,1,1);
 s:=LowerCase(s);
 if s='white' then s:='FFFFFF';
 if s='black' then s:='000000';
 if s='lime' then s:='00FF00';
 if s='red' then s:='FF0000';
 if s='blue' then s:='0000FF';
 if s='gray' then s:='808080';
 if s='yellow' then s:='FFFF00';
 if s='fuchsia' then s:='FF00FF';
 if s='purple' then s:='800080';
 if s='orange' then s:='FF8000';
 if s='teal' then s:='008080';
 if s='aqua' then s:='00FFFF';
 if s='green' then s:='008000';
 if s='silver' then s:='C0C0C0';
 if s='maroon' then s:='800000';
 if s='olive' then s:='808000';
 s1:=copy(s,1,2);
 s2:=copy(s,3,2);
 s3:=copy(s,5,2);
 s:='$00'+s3+s2+s1;
 try
   Result:=strtoint(s);
  except
    on exception do begin
      Result:=0;
    end;
 end;
end;

function ModColor(i: integer; scale: double):integer;
var
 s,s1,s2,s3:string;
begin
 s:=inttohex(i,6);
 s1:=copy(s,1,2);
 s1:=IntToStr(Round(StrToInt('$00'+s1)*scale));
 s2:=copy(s,3,2);
 s2:=IntToStr(Round(StrToInt('$00'+s2)*scale));
 s3:=copy(s,5,2);
 s3:=IntToStr(Round(StrToInt('$00'+s3)*scale));
 s:='$00'+s1+s2+s3;
 try
   Result:=strtoint(s);
  except
    on exception do begin
      Result:=0;
    end;
 end;
end;

function SplitString(const s: string; const Token: string): TStringList;
var
 tmps: string;         // Holds the string that has remained of s
 posi: integer;        // Holds the next position of Token
 toklen: integer;      // Holds the length of Token (default 1)
begin
 toklen:=Length(Token);
 Result:=TStringList.Create;
 tmps := s;
 posi := Pos(Token, tmps);
 while posi <> 0 do begin
   Result.Add(Copy(tmps, 1, posi - 1));
   Delete(tmps, 1, posi - 1 + toklen);
   posi:=Pos(Token, tmps);
 end;
 Result.Add(tmps);
end;

function ListToString(const lst: TStringList; const Token: string): string;
var
 indx: integer;
begin
 Result := '';
 for indx:=lst.Count - 1 downto 0 do
   Result:=lst[indx] + Token + Result;
 Delete(Result, Length(Result)-Length(Token)+1, Length(Token));
end;

function BoolToInt(value: boolean):integer;
begin
 if value then Result:=1 else Result:=0;
end;

function GetFileExtNP(fn: string):string;
begin
 Result:=Replace(ExtractFileExt(fn),'.','',false);
end;

function ExtractFileExtNP(fn: string):string;
begin
 Result:=Replace(ExtractFileExt(fn),'.','',false);
end;

function RemoveFileExt(fn: string):string;
var
 x: integer;
begin
 x:=length(fn); // abcd.txt
 Result:=fn;
 if pos('.',fn)=0 then exit;
 while fn[x]<>'.' do begin
   delete(fn,x,1);
   dec(x);
 end;
 if x>1 then delete(fn,x,1);
 Result:=fn;
end;

function GetFileDate(filename:string):Tdatetime;
begin
 if fileexists(filename) then
   Result:=filedatetodatetime(fileage(filename)) else result:=maxint;
end;

function AmpToSymbols(s: string; const convex: boolean = true):string;
begin
 s:=replace(s,'&copy;','',false);
 s:=replace(s,'&quot;','"',false);
 s:=replace(s,'&reg;','',false);
 s:=replace(s,'&trade;','',false);
 s:=replace(s,'&quot;','"',false);
 s:=replace(s,'&laquo;','',false);
 s:=replace(s,'&raquo;','',false);
 s:=replace(s,'&ndash;','',false);
 s:=replace(s,'&mdash;','',false);
 if convex then begin
   s:=replace(s,'&lt;','<',false);
   s:=replace(s,'&gt;','>',false);
   s:=replace(s,'&nbsp;',' ',false);
   s:=replace(s,'&amp;','&',false);
 end;
 Result:=s;
end;

function SymbolsToAmp(s: string; const convex: boolean = true):string;
begin
 if convex then begin
   s:=replace(s,'&','&amp;',false); //should first!
   s:=replace(s,'<','&lt;',false);
   s:=replace(s,'>','&gt;',false);
   s:=replace(s,' ','&nbsp;',false);
 end;
 s:=replace(s,'','&copy;',false);
 s:=replace(s,'"','&quot;',false);
 s:=replace(s,'','&reg;',false);
 s:=replace(s,'','&laquo;',false);
 s:=replace(s,'','&raquo;',false);
 s:=replace(s,'','&ndash;',false);
 s:=replace(s,'','&mdash;',false);
 Result:=replace(s,'','&trade;',false);
end;

function UnBrake(s: string):string;
begin
 if length(s)=0 then exit;
 if s[1]='"' then delete(s,1,1);
 if s[length(s)]='"' then delete(s,length(s),1);
 Result:=s;
end;

function UnGarbage(s: string):string;
begin
 if length(s)=0 then exit;
 while s[1]=' ' do delete(s,1,1);
 while s[1]='(' do delete(s,1,1);
 if s[length(s)]=')' then delete(s,length(s),1);
 Result:=s;
end;

function GetCpNumber(s: string):integer;
begin
 s:=lowercase(s);
 Result:=1251;
 if s='iso-8859-1' then Result:=591;
 if s='iso-8859-2' then Result:=592;
 if s='iso-8859-3' then Result:=593;
 if s='iso-8859-4' then Result:=594;
 if s='iso-8859-5' then Result:=595;
 if s='iso-8859-6' then Result:=596;
 if s='iso-8859-7' then Result:=597;
 if s='windows-1250' then Result:=1250;
 if s='windows-1251' then Result:=1251;
 if s='windows-1252' then Result:=1252;
 if s='windows-1257' then Result:=1257;
 if s='koi8-r' then Result:=8;
 if s='koi8-u' then Result:=88;
 if ((pos('dos',s)>0) or (pos('alt',s)>0)) and (pos('866',s)>0) then Result:=866;
end;

function HexToStr(hex: string):string;
var
 i,j: integer;
 h,s: string;
begin
 i:=0;
 while true do begin
   if i >= length(hex) then break;
   inc(i);
   h:=hex[i];
   inc(i);
   h:=h+hex[i];
   j:=StrToInt('$'+h);
   s:=s+chr(j);
 end;
 Result:=s;
end;

function StrToHex(str: string):string;
var
 j: integer;
 h: string;
begin
 for j:=1 to length(str) do begin
   h:=h+inttohex(ord(str[j]),2);
 end;
 Result:=h;
end;

function DateToInStr(date: TDateTime):string;
var
 y,m,d: word;
 s: string;
begin
 DecodeDate(date,y,m,d);
 if y<100 then begin
   if y>50 then y:=y+1900 else y:=y+2000;
 end;
 Result:=IntToStr(y);
 s:=IntToStr(m);
 if length(s)<2 then s:='0'+s;
 Result:=Result+s;
 s:=IntToStr(d);
 if length(s)<2 then s:='0'+s;
 Result:=Result+s;
end;

function InStrToDate(str: string):TDateTime;
var
 y,m,d: word;
begin
 Result:=now;
 if Length(str)<8 then exit;
 y:=StrToIntDef(copy(str,1,4),2001);
 if y<100 then begin
   if y>50 then y:=y+1900 else y:=y+2000;
 end;
 m:=StrToIntDef(copy(str,5,2),1);
 d:=StrToIntDef(copy(str,7,2),1);
 Result:=EncodeDate(y,m,d);
end;

function TimeToInStr(date: TDateTime):string;
var
 h,m,se,mse: word;
 s: string;
begin
 DecodeTime(date,h,m,se,mse);
 s:=IntToStr(h);
 if length(s)<2 then s:='0'+s;
 Result:=s;
 s:=IntToStr(m);
 if length(s)<2 then s:='0'+s;
 Result:=Result+s;
 s:=IntToStr(se);
 if length(s)<2 then s:='0'+s;
 Result:=Result+s;
end;

function InStrToTime(str: string):TDateTime;
var
 h,m,s: word;
begin
 Result:=0;
 if Length(str)<6 then exit;
 h:=StrToIntDef(copy(str,1,2),0);
 m:=StrToIntDef(copy(str,3,2),0);
 s:=StrToIntDef(copy(str,5,2),1);
 Result:=EncodeTime(h,m,s,0);
end;

function DateTimeToInStr(date: TDateTime):string;
begin
 Result:=DateToInStr(date)+TimeToInStr(date);
end;

function InStrToDateTime(str: string):TDateTime;
begin
 Result:=0;
 if Length(str)<14 then exit;
 Result:=InStrToDate(copy(str,1,8))+InStrToTime(copy(str,9,6))
end;

function DateTimeToWeb(date: TDateTime):string;
var
 y,m,d,h,min,sec,ms,w: word;
 s,s1,t,gmt: string;
 tzo,x: integer;
 tz: _Time_Zone_Information;
begin
 Result:='';
 DecodeDateFully(date,y,m,d,w);
 DecodeTime(date,h,min,sec,ms);
 case w of
  1: s:='Sun';
  2: s:='Mon';
  3: s:='Tue';
  4: s:='Wed';
  5: s:='Thu';
  6: s:='Fri';
  7: s:='Sat';
 end;
 case m of
  1: s1:='Jan';
  2: s1:='Feb';
  3: s1:='Mar';
  4: s1:='Apr';
  5: s1:='May';
  6: s1:='Jun';
  7: s1:='Jul';
  8: s1:='Aug';
  9: s1:='Sep';
  10: s1:='Oct';
  11: s1:='Nov';
  12: s1:='Dec';
 end;
 t:=IntToStr(h);
 if length(t)<2 then t:='0'+t;
 Result:=t+':';
 t:=IntToStr(min);
 if length(t)<2 then t:='0'+t;
 Result:=Result+t+':';
 t:=IntToStr(sec);
 if length(t)<2 then t:='0'+t;
 Result:=Result+t;
 GetTimeZoneInformation(tz);
 tzo:=tz.Bias;
 if tzo=0 then gmt:='GMT' else begin
   if tzo>0 then gmt:='+' else begin
     tzo:=-tzo;
     gmt:='-';
   end;
   x:=tzo div 60;
   t:=IntToStr(x);
   if length(t)<2 then t:='0'+t;
   gmt:=gmt+t;
   x:=tzo mod 60;
   t:=IntToStr(x);
   if length(t)<2 then t:='0'+t;
   gmt:=gmt+t;
 end;
 Result:=s+', '+IntToStr(d)+' '+s1+' '+IntToStr(y)+' '+Result+' '+gmt;
end;

end.

